// XDISKWIN2View.cpp : CXDISKWIN2View NX̓̒`s܂B
//

#include "headers.h"
#include "XDISKWIN2.h"
#include "XDISKWIN2Doc.h"
#include "XDISKWIN2View.h"
#include "SetupDlg.h"
#include "ImageDlg.h"
#include "main2.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//	EChẼLvVɕ\镶
LPCTSTR pszModeName[] = {
	" 88pVXeM",
	" ROMt@CM",
	" fBXNC[WM",
	" fBXNC[WM",
	" 80p[_M",
};

//	O[oϐ
extern XDISKPARAM xparam;
extern char g_msg[];

/////////////////////////////////////////////////////////////////////////////
// CXDISKWIN2View

IMPLEMENT_DYNCREATE(CXDISKWIN2View, CFormView)

BEGIN_MESSAGE_MAP(CXDISKWIN2View, CFormView)
	//{{AFX_MSG_MAP(CXDISKWIN2View)
	ON_BN_CLICKED(IDC_CMD_FILEREF, OnCmdFileref)
	ON_BN_CLICKED(IDC_CMD_DISKREF, OnCmdDiskref)
	ON_WM_DESTROY()
	ON_COMMAND(ID_MODE_88SYS, OnMode88sys)
	ON_COMMAND(ID_MODE_DISKGET, OnModeDiskget)
	ON_COMMAND(ID_MODE_DISKPUT, OnModeDiskput)
	ON_COMMAND(ID_MODE_ROMGET, OnModeRomget)
	ON_COMMAND(ID_MODE_80LOADER, OnMode80loader)
	ON_BN_CLICKED(IDC_CMD_EXEC, OnCmdExec)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPN_DISKREF, OnDeltaposSpnDiskref)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPN_DRIVE, OnDeltaposSpnDrive)
	ON_COMMAND(ID_FILE_SETUP, OnFileSetup)
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
	{ WM_USER+1, 0, 0, 0, AfxSig_vwl, \
		(AFX_PMSG)(AFX_PMSGW)(void (AFX_MSG_CALL CWnd::*)(UINT, LPARAM))&OnMsgGet },
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CXDISKWIN2View NX̍\z/

CXDISKWIN2View::CXDISKWIN2View()
	: CFormView(CXDISKWIN2View::IDD)
{
	//{{AFX_DATA_INIT(CXDISKWIN2View)
	m_protect = FALSE;
	m_diskName = _T("");
	m_fileName = _T("");
	m_folderName = _T("");
	m_modeName = _T("");
	m_drive = 0;
	m_media = -1;
	//}}AFX_DATA_INIT

	m_height = 0;

	//	O̊i[tH_(EXËʒu)擾
	char szBuf[_MAX_PATH];

	GetModuleFileName(0, szBuf, _MAX_PATH);

	LPTSTR filepart;
	GetFullPathName(szBuf, _MAX_PATH, m_modulePath, &filepart);

	*filepart = 0;
	m_folderName = (LPSTR)m_modulePath;

	//	ݒt@C̓ǂݍ
	CString csIniFile;
	csIniFile = m_modulePath;
	csIniFile += INI_FILE_NAME;

	m_mode		= GetPrivateProfileInt("COMMON",    "MODE",      0, csIniFile);
	m_verbose	= GetPrivateProfileInt("COMMON",    "VERBOSE",   0, csIniFile);
	m_baudrate	= GetPrivateProfileInt("PARAMETER", "BAUDRATE",  0, csIniFile);
	m_port		= GetPrivateProfileInt("PARAMETER", "PORT",      0, csIniFile);
	m_drive		= GetPrivateProfileInt("PARAMETER", "DRIVE",     1, csIniFile);
	m_protect	= GetPrivateProfileInt("PARAMETER", "PROTECT",   0, csIniFile);
	m_media		= GetPrivateProfileInt("PARAMETER", "MEDIA",     0, csIniFile);
	m_fast		= GetPrivateProfileInt("PARAMETER", "FAST",      1, csIniFile);
	m_x			= GetPrivateProfileInt("WINDOW",	"LEFT",		-1, csIniFile);
	m_y			= GetPrivateProfileInt("WINDOW",	"TOP",		-1, csIniFile);
	m_cx		= GetPrivateProfileInt("WINDOW",	"WIDTH",	-1, csIniFile);
	m_cy		= GetPrivateProfileInt("WINDOW",	"HEIGHT",	-1, csIniFile);
	GetPrivateProfileString("FOLDER", "OUTPUT", m_modulePath, szBuf, _MAX_PATH, csIniFile);
	m_folderName = szBuf;
	m_modeName = pszModeName[m_mode];
}

CXDISKWIN2View::~CXDISKWIN2View()
{
}

void CXDISKWIN2View::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CXDISKWIN2View)
	DDX_Control(pDX, IDC_LST_DISP, m_disp);
	DDX_Control(pDX, IDC_CMD_EXEC, m_ctlExec);
	DDX_Check(pDX, IDC_CHK_PROTECT, m_protect);
	DDX_Text(pDX, IDC_EDT_DISK_NAME, m_diskName);
	DDX_Text(pDX, IDC_EDT_FILE_NAME, m_fileName);
	DDX_Text(pDX, IDC_EDT_FOLDER_NAME, m_folderName);
	DDX_Text(pDX, IDC_LBL_MODE, m_modeName);
	DDX_Text(pDX, IDC_EDT_DRIVE, m_drive);
	DDX_CBIndex(pDX, IDC_CMB_MEDIA, m_media);
	//}}AFX_DATA_MAP
}

BOOL CXDISKWIN2View::PreCreateWindow(CREATESTRUCT& cs)
{
	return CFormView::PreCreateWindow(cs);
}

void CXDISKWIN2View::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();
	GetParentFrame()->RecalcLayout();
	ResizeParentToFit();

	((CEdit*)GetDlgItem(IDC_EDT_FOLDER_NAME))->LimitText(_MAX_PATH);
	((CEdit*)GetDlgItem(IDC_EDT_FILE_NAME))->LimitText(_MAX_PATH);
	((CEdit*)GetDlgItem(IDC_EDT_DRIVE))->LimitText(1);

	SetModeMenu(m_mode);

	CFrameWnd* pFrame = EnsureParentFrame();
	if (pFrame != NULL && m_cx != -1 && m_cy != -1)
	{
		pFrame->SetWindowPos(NULL, m_x, m_y, m_cx, m_cy, 
			SWP_NOZORDER | SWP_NOACTIVATE /*| SWP_NOMOVE*/);
	}
}

/////////////////////////////////////////////////////////////////////////////
// CXDISKWIN2View NX̐ff

#ifdef _DEBUG
void CXDISKWIN2View::AssertValid() const
{
	CFormView::AssertValid();
}

void CXDISKWIN2View::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CXDISKWIN2Doc* CXDISKWIN2View::GetDocument() // fobO o[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CXDISKWIN2Doc)));
	return (CXDISKWIN2Doc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CXDISKWIN2View [U֐

//	JgtH_ύX
bool CXDISKWIN2View::SetFolder(void)
{
	UpdateData(TRUE);

	m_fileName.TrimLeft();
	m_fileName.TrimRight();
	m_diskName.TrimLeft();
	m_diskName.TrimRight();
	m_folderName.TrimLeft();
	m_folderName.TrimRight();

	//	88pVXe]̎̓W[̃tH_Ɉړ
	if (m_mode == 0) {
		_chdrive(toupper(m_modulePath[0]) - 'A' + 1);
		_chdir(m_modulePath);
		return true;
	}

	if (m_folderName[0] == '\0') {
		//	tH_w肳ĂȂƂ̓W[̃tH_Ɉړ
		_chdrive(toupper(m_modulePath[0]) - 'A' + 1);
		_chdir(m_modulePath);
		return true;
	} else {
		//	[Uw̃tH_Ɉړ
		if (isalpha(m_folderName[0]) && m_folderName[1] == ':') {
			if (_chdrive(toupper(m_folderName[0]) - 'A' + 1)) {
				ErrMsgBox("hCu̎w肪܂");
				return false;
			}
		}
		if (_chdir(m_folderName)) {
			ErrMsgBox("tH_̎w肪܂");
			return false;
		}
	}
	return true;
}

/////////////////////////////////////////////////////////////////////////////
// CXDISKWIN2View NX̃bZ[W nh

//	XDISK̃bZ[Wʒm
void CXDISKWIN2View::OnMsgGet(WPARAM wParam, LPARAM lParam)
{
	if (m_msgCR) {
		if (g_msg[0])
			m_disp.DeleteString(m_disp.GetCount() - 1);
		m_msgCR = false;
	}

	switch(wParam) {
	case 0:		//	XDISK̏I
		m_ctlExec.EnableWindow(TRUE);
		break;
	case 1:		//	\ǉ
		m_msg += g_msg;
		break;
	case 2:		//	\isj
		m_msg += g_msg;
		m_disp.AddString(m_msg);
		m_msg.Empty();
		m_msgCR = true;
		break;
	case 3:		//	\
		m_msg += g_msg;
		m_disp.AddString(m_msg);
		m_msg.Empty();
		break;
	}
	//	XgŌ̕\
	int nCount = m_disp.GetCount();
	int nLines = m_height / m_disp.GetItemHeight(0);
	if (nCount > nLines) {
		m_disp.SetTopIndex(nCount - nLines > 0 ? nCount - nLines : 0);
	}
}

/////////////////////////////////////////////////////////
//	WINDOWSbZ[W
/////////////////////////////////////////////////////////

//	vOI
void CXDISKWIN2View::OnDestroy() 
{
	UpdateData(TRUE);

	//	ݒt@C̏
	CString csIniFile;
	CString cs;
	csIniFile = m_modulePath;
	csIniFile += INI_FILE_NAME;

	WritePrivateProfileInt("COMMON",    "MODE",     m_mode,       csIniFile);
	WritePrivateProfileInt("COMMON",    "VERBOSE",  m_verbose,    csIniFile);
	WritePrivateProfileInt("PARAMETER", "BAUDRATE", m_baudrate,   csIniFile);
	WritePrivateProfileInt("PARAMETER", "PORT",     m_port,       csIniFile);
	WritePrivateProfileInt("PARAMETER", "DRIVE",    m_drive,      csIniFile);
	WritePrivateProfileInt("PARAMETER", "PROTECT",  m_protect,    csIniFile);
	WritePrivateProfileInt("PARAMETER", "MEDIA",    m_media,      csIniFile);
	WritePrivateProfileInt("PARAMETER", "FAST",     m_fast,       csIniFile);

	WritePrivateProfileString("FOLDER", "OUTPUT",   m_folderName, csIniFile);

	CFrameWnd* pFrame = EnsureParentFrame();
	if (pFrame != NULL && !pFrame->IsIconic())
	{
		RECT rect;
		pFrame->GetWindowRect(&rect);
		if (rect.left > -32000 && rect.top > -32000)
		{
			WritePrivateProfileInt("WINDOW", "LEFT",   rect.left,				csIniFile);
			WritePrivateProfileInt("WINDOW", "TOP",	   rect.top,				csIniFile);
			WritePrivateProfileInt("WINDOW", "WIDTH",  rect.right  - rect.left, csIniFile);
			WritePrivateProfileInt("WINDOW", "HEIGHT", rect.bottom - rect.top,  csIniFile);
		}
	}

	CFormView::OnDestroy();
}
//	EChETCYύX
void CXDISKWIN2View::OnSize(UINT nType, int cx, int cy) 
{
	CFormView::OnSize(nType, cx, cy);
	
	CRect cr;

	GetClientRect(&cr);

	cr.top	  = 100;
	cr.left	  = 4;
	cr.right  = cx - 4; 
	cr.bottom = cy - 4;
	if (::IsWindow(m_disp)) {
		m_disp.MoveWindow(&cr, FALSE);
		m_height = cy-132;
	}
}


/////////////////////////////////////////////////////////
//	j[
/////////////////////////////////////////////////////////

//	ݒ_CAO
void CXDISKWIN2View::OnFileSetup() 
{
	CSetupDlg csd(this);	
	csd.DoModal();
}

//	샂[hύX
void CXDISKWIN2View::OnMode88sys()	  { SetModeMenu(0); }
void CXDISKWIN2View::OnModeDiskget()  { SetModeMenu(2); }
void CXDISKWIN2View::OnModeDiskput()  { SetModeMenu(3); }
void CXDISKWIN2View::OnModeRomget()	  { SetModeMenu(1); }
void CXDISKWIN2View::OnMode80loader() { SetModeMenu(4); }
void CXDISKWIN2View::SetModeMenu(int nNewMode)
{
	m_mode = nNewMode;

	CMenu*	pMenu = this->GetParent()->GetMenu();
	pMenu->CheckMenuItem(ID_MODE_88SYS,    MF_BYCOMMAND | (m_mode == 0 ? MF_CHECKED : MF_UNCHECKED));
	pMenu->CheckMenuItem(ID_MODE_ROMGET,   MF_BYCOMMAND | (m_mode == 1 ? MF_CHECKED : MF_UNCHECKED));
	pMenu->CheckMenuItem(ID_MODE_DISKGET,  MF_BYCOMMAND | (m_mode == 2 ? MF_CHECKED : MF_UNCHECKED));
	pMenu->CheckMenuItem(ID_MODE_DISKPUT,  MF_BYCOMMAND | (m_mode == 3 ? MF_CHECKED : MF_UNCHECKED));
	pMenu->CheckMenuItem(ID_MODE_80LOADER, MF_BYCOMMAND | (m_mode == 4 ? MF_CHECKED : MF_UNCHECKED));

	UpdateData(TRUE);
	m_modeName = pszModeName[m_mode];
	m_diskName = (m_mode == 3 ? "1" : "");
	UpdateData(FALSE);
	GetDocument()->SetTitle(pszModeName[m_mode]);
	((CEdit*)GetDlgItem(IDC_EDT_DISK_NAME))->LimitText(m_mode == 3 ? 3 : 16);
}


/////////////////////////////////////////////////////////
//	j[
/////////////////////////////////////////////////////////

//	t@CQƃ{^
void CXDISKWIN2View::OnCmdFileref() 
{
	UpdateData(TRUE);
	
	OPENFILENAME ofn;
	char szPath[_MAX_PATH];

	memset(&ofn, 0, sizeof(ofn));
	szPath[0] = '\0';
	ofn.lStructSize = sizeof(ofn);
	ofn.hwndOwner = (HWND)this->GetSafeHwnd();
	ofn.lpstrFilter = "8801 disk image (*.d88)\0*.D88\0"
					  "All Files (*.*)\0*.*\0";
	ofn.lpstrFile = szPath;
	ofn.lpstrInitialDir = (LPCTSTR)m_folderName;
	ofn.nMaxFile = _MAX_PATH;
	ofn.Flags = OFN_CREATEPROMPT | OFN_HIDEREADONLY;
	ofn.lpstrDefExt = "D88";
	ofn.lpstrTitle = "C[Wt@C̓";
	
	BOOL bGet = (m_mode == 2 ? GetSaveFileName(&ofn) : GetOpenFileName(&ofn));

	if (bGet)
	{
		char szBuf[_MAX_PATH];

		LPTSTR filepart;
		GetFullPathName(szPath, _MAX_PATH, szBuf, &filepart);

		m_fileName = (LPSTR)filepart;
		*filepart = 0;
		m_folderName = (LPSTR)szBuf;
		UpdateData(FALSE);
	}
}
//	fBXNeQƃ{^
void CXDISKWIN2View::OnCmdDiskref() 
{
	SetFolder();
	m_temp = (m_mode == 3 ? atoi(m_diskName) : 0);

	char szPath[_MAX_PATH];
	strcpy(szPath, m_fileName);	
	//	t@CJ
	if (false == m_file.Open(szPath, 0)) {
		//	t@C݂Ȃꍇ͊gq"D88"tčēxt@CJ
		BYTE *pLast;
		pLast = _mbsrchr( (BYTE*)szPath, '.' );
		if (!pLast || (pLast  && stricmp((char*)pLast, ".D88") != 0)) {
			strcat(szPath, ".D88");
		}
		if (false == m_file.Open(szPath, 0)) {
			ErrMsgBox("w肵t@CJ܂");
			return;
		}
	}

	CImageDlg cid(this);
	if (IDOK == cid.DoModal() && m_temp) {
		m_diskName.Format("%d", m_temp);
		UpdateData(FALSE);
	}
	m_file.Close();
}
//	s{^
void CXDISKWIN2View::OnCmdExec() 
{
	SetFolder();

	//	p[^Rs[
	int nd = sizeof(xparam.szDiskName);
	int nf = sizeof(xparam.szFileName);

	memset(xparam.szDiskName, 0, sizeof(xparam.szDiskName));
	memset(xparam.szFileName, 0, sizeof(xparam.szFileName));
	strcpy(xparam.szDiskName, m_diskName);
	strcpy(xparam.szFileName, m_fileName);
	xparam.bProtect = m_protect;
	xparam.drive    = m_drive;
	xparam.baudrate = m_baudrate;
	xparam.port     = m_port;
	xparam.mode     = m_mode;
	xparam.hwnd     = m_hWnd;
	xparam.bFast	= m_fast;
	xparam.bVerbose	= m_verbose;
	xparam.media	= m_media;

	//	w肳ꂽt@C݂Ȃꍇ͊gq"D88"
	FileIO fio;
	if (false == fio.Open(xparam.szFileName, 0)) {
		BYTE *pLast;
		pLast = _mbsrchr( (BYTE*)xparam.szFileName, '.' );
		if (!pLast || (pLast  && stricmp((char*)pLast, ".D88") != 0)) {
			strcat(xparam.szFileName, ".D88");
		}
	}
	else {
		fio.Close();
	}

	m_ctlExec.EnableWindow(FALSE);
	m_disp.ResetContent();
	m_msg.Empty();
	m_msgCR = false;

	unsigned long thd = 0;
	unsigned tid = 0;

	//	XDISKN
	thd = _beginthreadex(NULL, 0, CmdExecThread, &xparam, 0, &tid);
	if (thd) {
		CloseHandle((HANDLE)thd);
	}
}


/////////////////////////////////////////////////////////
//	XsRg[
/////////////////////////////////////////////////////////

//	fBXN
void CXDISKWIN2View::OnDeltaposSpnDiskref(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;

	UpdateData(TRUE);
	char	buf[_MAX_PATH];
	int		ch, ch2;
	bool	bChg = true;
	int		nLen = m_diskName.GetLength();

	memset(buf, 0, sizeof(buf));

	if (m_mode == 3) {
		int index = atoi(m_diskName);
		index -= pNMUpDown->iDelta;
		if (index < 1) index = 1;
		if (index > 999) index = 999;
		m_diskName.Format("%d", index);
		UpdateData(FALSE);
		return;
	}

	if (nLen == 0) return;

	if (pNMUpDown->iDelta) {
		strcpy(buf, (LPCSTR)m_diskName);
		switch(_mbsbtype( (const unsigned char *)buf, nLen - 1 )) {
		case _MBC_SINGLE:
			ch = (buf[nLen-1] + (pNMUpDown->iDelta < 0 ? 1 : -1)) & 0xff;
			switch (ch) {
			case 0x7f:
				ch = 0xa1; break;
			case 0xe0:
				bChg = false; break;
			case 0xa0:
				ch = 0x7e; break;
			case 0x1f:
				bChg = false; break;
			}
			if (bChg) {
				buf[nLen - 1] = ch;
				m_diskName = (char*)buf;
				UpdateData(FALSE);
				((CEdit*)GetDlgItem(IDC_EDT_DISK_NAME))->SetSel(0, -1, TRUE);
			}
			break;
		case _MBC_TRAIL:
			ch = buf[nLen - 2] & 0xff;
			ch2 = (buf[nLen-1] + (pNMUpDown->iDelta < 0 ? 1 : -1)) & 0xff;
			switch(ch2) {
			case 0x7f:
				ch2 += (pNMUpDown->iDelta < 0 ? 1 : -1); break;
			case 0xfd:
				ch2 = 0x40; ch++; break;
			case 0x3f:
				ch2 = 0xfc; ch--; break;
			}
			switch (ch) {
			case 0xa0:
				ch = 0xe0; break;
			case 0xfd:
				bChg = false; break;
			case 0xdf:
				ch = 0x9f; break;
			case 0x80:
				bChg = false; break;
			}
			if (bChg) {
				buf[nLen - 2] = ch;
				buf[nLen - 1] = ch2;
				if (_mbsbtype( (const unsigned char *)buf, nLen - 2 ) == _MBC_LEAD &&
					_mbsbtype( (const unsigned char *)buf, nLen - 1 ) == _MBC_TRAIL) {
					m_diskName = (char*)buf;
					UpdateData(FALSE);
					((CEdit*)GetDlgItem(IDC_EDT_DISK_NAME))->SetSel(0, -1, TRUE);
				}
			}
		}
	}
	
	*pResult = 0;
}
//	hCuԍ
void CXDISKWIN2View::OnDeltaposSpnDrive(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;

	UpdateData(TRUE);

	m_drive -= pNMUpDown->iDelta;
	if (m_drive < 1) m_drive = 1;
	if (m_drive > 2) m_drive = 2;

	UpdateData(FALSE);

	*pResult = 0;
}
