// main2.cpp : XDISK̋@\Ăяo܂B
//

#include "headers.h"
#include "XDISKWIN2.h"
#include "XDISKWIN2Doc.h"
#include "XDISKWIN2View.h"
#include "xdisk.h"
#include "main2.h"

bool verbose;
int version_l = 6;

XDISKPARAM xparam;
char g_msg[2048];

static void Send88System(uint port, uint baud);
static void Send80Loader(uint port, uint baud);
static bool D88Seek(FileIO& fio, int index);

unsigned _stdcall CmdExecThread(PVOID pv)
{
	int drive = xparam.drive;
//	int retry = 10;
	char filename[_MAX_PATH];
	char title[17];
	bool writeprotect = (xparam.bProtect ? true : false);
	bool fastrecv = (xparam.bFast ? true : false);
	verbose = (xparam.bVerbose ? true : false);
	int media = xparam.media - 1;
	uint baud = (xparam.baudrate ? 19200 : 9600);
	uint port = xparam.port + 1;
	int index = atoi(xparam.szDiskName);
	strcpy(filename, xparam.szFileName);
	strcpy(title, xparam.szDiskName);
	
	TransDisk2 xdisk;
	int e;

	int modeChar[] = { 'b', 's', 'r', 'w', 'e' };
	int mode = modeChar[xparam.mode];
	
	if (media == 2)
		media = 3;

	if ((mode == 'r' || mode == 'w') && !strlen(filename)) {
		ErrMsgBoxT("t@Cw肳Ă܂");
		goto EXIT_THREAD;
	}

	printf("ʐM|[g %d, %d bps Őڑ܂.\n\n", port, baud);

	switch (mode)
	{
	case 'b':
		Send88System(port, baud);
		goto EXIT_THREAD;
	case 'e':
		Send80Loader(port, baud);
		goto EXIT_THREAD;
	}

	e = xdisk.Connect(port, baud, fastrecv);

	if (e != XComm2::s_ok)
	{
		printf("ʐMfoCX̏Ɏs܂(%d).\n", e);
		goto EXIT_THREAD;
	}
	
	switch (mode)
	{
	case 'r':
		{
			FileIO file;
			if (!file.Open(filename, FileIO::openalways) 
				|| (file.GetFlags() & FileIO::readonly))
			{
				fprintf(stderr, "t@C܂.\n");
				goto EXIT_THREAD;
			}
			D88Seek(file, 99999);

			xdisk.ReceiveDisk(drive-1, media, file);
			file.Seek(0, FileIO::begin);
			file.Write(title, 16);
			file.Seek(26, FileIO::begin);
			uint8 wp = writeprotect ? 0x10 : 0;
			file.Write(&wp, 1);
		}
		break;
		
	case 'w':
		{
			FileIO file;
			
			if (!file.Open(filename, FileIO::readonly))
			{
				fprintf(stderr, "t@CJ܂.\n");
				goto EXIT_THREAD;
			}
			if (!D88Seek(file, index))
			{
				fprintf(stderr, "w肳ꂽfBXN܂.\n");
				goto EXIT_THREAD;
			}
			xdisk.SendDisk(drive-1, file);
		}
		break;

	case 's':
		xdisk.ReceiveROM();
		break;
	}
	printf("I܂B\n");

EXIT_THREAD:
	PostMessage(xparam.hwnd, WM_USER + 1, 0, 0);
	return 0;
}

static void Send88System(uint port, uint baud)
{
	SIO sio;
	if (SIO::OK != sio.Open(port, baud))
	{
		printf("ʐMfoCX̏Ɏs܂.\n");
		return;
	}

	int res = MsgBoxT("88 ɃvO]܂B\n"
					  "88  load \042COM:N81X\042 ƂR}hsĂB\n\n"
					  "낵ł ?");
	if (res == IDCANCEL)
	{
		return;
	}

	FileIO fio("xdisk2.bas", FileIO::readonly);
	fio.Seek(0, FileIO::end);
	uint size = fio.Tellp();
	if (size)
	{
		fio.Seek(0, FileIO::begin);

		int fs = size;
		while (fs > 0)
		{
			printf("] (%d%%).\r", (size-fs) * 100 / size);
			
			uint8 buf[512];
			uint ps = fs > sizeof(buf) ? sizeof(buf) : fs;
			fio.Read(buf, ps);
			//uint ps2 = ps;
			//if (fs == ps && buf[ps - 3] == '-' && buf[ps - 2] == '\r' && buf[ps - 1] == '\n') 
			//{
			//	ps2 -= 2;
			//}
			if (SIO::OK != sio.Write(buf, ps))
			{
				printf("]ł܂ł.\n");
				return;
			}

			fs -= ps;
		}
		printf("܂.\n");
	}
	else
	{
		printf("XDISK2.BAS܂.\n");
	}
}

static void Send80Loader(uint port, uint baud)
{
	SIO sio;
	if (SIO::OK != sio.Open(port, baud))
	{
		printf("ʐMfoCX̏Ɏs܂.\n");
		return;
	}

	int res = MsgBoxT("80mkII/SR ɏ[_\042RSLOAD.BAS\042]܂B\n"
					  "80mkII/SR  width 80:term a,0,1,0 ƂR}hsĂB\n\n"
					  "낵ł ?");
	if (res == IDCANCEL)
	{
		return;
	}

	FileIO fio("rsload.bas", FileIO::readonly);
	fio.Seek(0, FileIO::end);
	uint size = fio.Tellp();
	if (size)
	{
		fio.Seek(0, FileIO::begin);

		int fs = size;
		while (fs > 0)
		{
			printf("] (%d%%).\r", (size-fs) * 100 / size);
			
			uint8 buf[512];
			uint ps = 1;
			fio.Read(buf, ps);
			if (SIO::OK != sio.Write(buf, ps))
			{
				printf("]ł܂ł.\n");
				return;
			}
			Sleep(17);

			fs -= ps;
		}
		printf("܂.\n");
		printf("GRPH+BCJ[\ 9CRETURN 8L[͂Ă.\n");
	}
	else
	{
		printf("RSLOAD.BAS܂.\n");
	}
}

// ---------------------------------------------------------------------------

static bool D88Seek(FileIO& fio, int index)
{
	fio.Seek(0, FileIO::end);
	int dis = fio.Tellp();

	fio.SetLogicalOrigin(0);
	int pos = 0;

	int i;
	for (i=0; i<index && pos < dis; i++)
	{
		uint32 size = 0;

		fio.Seek(pos + 0x1c, FileIO::begin);
		fio.Read(&size, 4);
		if (size == 0xdeadd13c)
			break;
		if (size == 0 || size > 4 * 1024 * 1024)
			return false;
		if (i < index - 1)
			pos += size;
	}
	if (verbose)
		printf("disk index: %d\n");
	fio.SetLogicalOrigin(pos);
	fio.Seek(0, FileIO::begin);
	return (i == index);
}

int printf2(const char *szFormat, ...)
{
	va_list marker;

	va_start( marker, szFormat );
	vsprintf(g_msg, szFormat, marker);
	va_end( marker );

	int pos = strlen(g_msg) - 1;
	WPARAM wp = 1;
	switch(g_msg[pos]) {
	case '\r':
		wp = 2;
		g_msg[pos--] = '\0';
		break;
	case '\n':
		wp = 3;
		g_msg[pos--] = '\0';
		break;
	}
	while (pos >= 0 && iscntrl(g_msg[pos])) {
		g_msg[pos--] = '\0';
	}
	SendMessage(xparam.hwnd, WM_USER + 1, wp, 0);

	return 0;
}

int getchar(void)
{
	return MsgBoxT(g_msg);
}

